Index: /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/domain.f90
===================================================================
--- /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/domain.f90	(revision 5212)
+++ /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/domain.f90	(revision 5213)
@@ -1010,28 +1149,22 @@
 
          ! west part bigger than east part
-         CALL logger_trace("DEFINE POLE OVERLAP: west part bigger than east part ")
+         CALL logger_trace("DOM SIZE POLE OVERLAP: west part bigger than east part ")
 
          ! to respect symmetry around asian bipole
          td_dom%i_imin = td_dom%t_dim0(1)%i_len - il_idom2 + 1
 
+         IF( td_dom%i_jmin == 0 ) td_dom%i_jmin = 1 
          ! north pole
-         IF( td_dom%i_jmax >= td_dom%t_dim0(2)%i_len-1 )THEN
-            td_dom%i_jmax=MIN( td_dom%i_jmin, & 
-            &                  td_dom%t_dim0(2)%i_len-td_dom%i_jmax )
-         ELSE
-            td_dom%i_jmax=MIN( td_dom%i_jmin, td_dom%i_jmax )
-         ENDIF
-         td_dom%i_jmin=td_dom%i_jmax
+         td_dom%i_jmax=td_dom%t_dim0(2)%i_len
 
          ! compute size
          td_dom%t_dim(1)%i_len = il_idom2
          td_dom%t_dim(2)%i_len = ( td_dom%t_dim0(2)%i_len - &
-         &                         ( td_dom%i_jmin ) + 1 ) + &
+         &                         td_dom%i_jmin + 1 ) + &
          &                         ( td_dom%t_dim0(2)%i_len - &
-         &                         ( td_dom%i_jmax ) + 1 ) - 2
+         &                         td_dom%i_jmin + 1 ) - 2
 
          ! add ghost cell
-         td_dom%i_ighost=1
-         td_dom%i_jghost=1
+         td_dom%i_ghost(:,:)=1
          
          ! periodicity
@@ -1041,17 +1174,15 @@
 
    END SUBROUTINE dom__size_pole_overlap
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine compute size of an extract domain with north fold
+   !> This subroutine compute size of sub domain with north fold
    !> condition, and which do not overlap east-west boundary
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Subroutine written
-   !
-   !> @param[inout] td_dom : domain strcuture
+   !> - November, 2013- Subroutine written
+   !
+   !> @param[inout] td_dom domain strcuture
    !> @note never tested
    !-------------------------------------------------------------------
-   !> @code
    SUBROUTINE dom__size_pole_no_overlap( td_dom )
       IMPLICIT NONE
@@ -1065,21 +1196,16 @@
       !----------------------------------------------------------------
 
-      IF( td_dom%i_imin >= td_dom%i_imax )THEN
-         CALL logger_fatal("DOM INIT: invalid domain. "//&
+      IF( td_dom%i_imin == 0 .OR. td_dom%i_imax == 0 .OR. &
+      &   td_dom%i_imin > td_dom%i_imax )THEN
+         CALL logger_fatal("DOM SIZE POLE NO OVERLAP: invalid domain. "//&
          &  "can not overlap East-West boundary with this coarse grid. "//&
          &  "check namelist and coarse grid periodicity." )
       ENDIF
 
-      CALL logger_trace("DEFINE POLE NO OVERLAP: "//&
+      CALL logger_trace("DOM SIZE POLE NO OVERLAP: "//&
       &  "no asian bipole inside domain to extract")
 
-      ! north pole
-      IF( td_dom%i_jmax >= td_dom%t_dim0(2)%i_len-1 )THEN
-         td_dom%i_jmax=MIN( td_dom%i_jmin, & 
-         &                  td_dom%t_dim0(2)%i_len-td_dom%i_jmax )
-      ELSE
-         td_dom%i_jmax=MIN( td_dom%i_jmin, td_dom%i_jmax )
-      ENDIF
-      td_dom%i_jmin=td_dom%i_jmax
+      IF( td_dom%i_jmin==0 ) td_dom%i_jmin = 1
+      IF( td_dom%i_jmax==0 ) td_dom%i_jmax = td_dom%t_dim0(2)%i_len
 
       ! 
@@ -1088,18 +1214,17 @@
       IF( (td_dom%i_imin < il_mid .AND. td_dom%i_imax < il_mid) .OR. &
       &   (td_dom%i_imin > il_mid .AND. td_dom%i_imax > il_mid) )THEN
-         CALL logger_trace("DEFINE POLE NO OVERLAP: "//&
+         CALL logger_trace("DOM SIZE POLE NO OVERLAP: "//&
          &  "no canadian bipole inside domain to extract")
 
-         td_dom%t_dim(1)%i_len = ( td_dom%i_imax ) - &
-         &                       ( td_dom%i_imin ) + 1
+         td_dom%t_dim(1)%i_len = td_dom%i_imax - &
+         &                       td_dom%i_imin + 1
 
          td_dom%t_dim(2)%i_len = ( td_dom%t_dim0(2)%i_len - &
-         &                       ( td_dom%i_jmin ) + 1 ) + &
+         &                       td_dom%i_jmin + 1 ) + &
          &                       ( td_dom%t_dim0(2)%i_len - &
-         &                       ( td_dom%i_jmax ) + 1 ) - 2 ! remove north fold condition ?
+         &                       td_dom%i_jmin + 1 ) - 2 ! remove north fold condition ?
 
          ! add ghost cell
-         td_dom%i_ighost=1
-         td_dom%i_jghost=1
+         td_dom%i_ghost(:,:)=1
 
          ! periodicity
@@ -1107,5 +1232,5 @@
 
       ELSE ! id_imin < il_mid .AND. id_imax > il_mid
-         CALL logger_trace("DEFINE POLE NO OVERLAP: "//&
+         CALL logger_trace("DOM SIZE POLE NO OVERLAP: "//&
          &  "canadian bipole inside domain to extract")
 
@@ -1114,5 +1239,5 @@
          IF( il_idom1 > il_idom2 )THEN
             ! east part bigger than west part
-            CALL logger_trace("DEFINE POLE NO OVERLAP: east part bigger than west part ")
+            CALL logger_trace("DOM SIZE POLE NO OVERLAP: east part bigger than west part ")
             ! to respect symmetry around canadian bipole
             td_dom%i_imin = il_mid - il_idom1
@@ -1120,12 +1245,11 @@
             td_dom%t_dim(1)%i_len = il_idom1 + 1
             td_dom%t_dim(2)%i_len = ( td_dom%t_dim0(2)%i_len - &
-            &                         ( td_dom%i_jmin ) + 1 ) + & 
+            &                         td_dom%i_jmin + 1 ) + & 
             &                         ( td_dom%t_dim0(2)%i_len - &
-            &                         ( td_dom%i_jmax ) + 1 ) &   
+            &                         td_dom%i_jmin + 1 ) &   
             &                         - 2 - 2 * td_dom%i_pivot    ! remove north fold condition ?
 
             ! add ghost cell
-            td_dom%i_ighost=1
-            td_dom%i_jghost=1
+            td_dom%i_ghost(:,:)=1
 
             ! periodicity
@@ -1134,5 +1258,5 @@
          ELSE ! il_idom2 >= il_idom1
             ! west part bigger than east part
-            CALL logger_trace("DEFINE POLE NO OVERLAP: west part bigger than east part ")
+            CALL logger_trace("DOM SIZE POLE NO OVERLAP: west part bigger than east part ")
             ! to respect symmetry around canadian bipole
 
@@ -1141,12 +1265,11 @@
             td_dom%t_dim(1)%i_len = il_idom2 + 1
             td_dom%t_dim(2)%i_len = ( td_dom%t_dim0(2)%i_len -  &
-            &                         ( td_dom%i_jmin ) + 1 ) +     & 
+            &                         td_dom%i_jmin + 1 ) +     & 
             &                         ( td_dom%t_dim0(2)%i_len -  &
-            &                         ( td_dom%i_jmax ) + 1 )       & 
+            &                         td_dom%i_jmax + 1 )       & 
             &                         - 2 - 2 * td_dom%i_pivot  !  remove north fold condition ?
 
             ! add ghost cell
-            td_dom%i_ighost=1
-            td_dom%i_jghost=1
+            td_dom%i_ghost(:,:)=1
 
             ! periodicity
@@ -1157,121 +1280,24 @@
 
    END SUBROUTINE dom__size_pole_no_overlap
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function get east west overlap.
-   !
+   !-------------------------------------------------------------------
+   !> @brief 
+   !>  This subroutine add extra bands to coarse domain to get enough point for
+   !>  interpolation...
+   !>
    !> @details
-   !> If no east -west wrap return -1, 
-   !> else return the size of the ovarlap band 
-   !
-   !> @author J.Paul
-   !> - 2013- Initial Version
-   !
-   !> @param[in] 
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION dom_get_ew_overlap(td_lon)
-      IMPLICIT NONE
-      ! Argument      
-      TYPE(TVAR), INTENT(IN) :: td_lon
-
-      ! function
-      INTEGER(i4) :: dom_get_ew_overlap
-
-      ! local variable
-      REAL(dp), DIMENSION(:,:,:,:), ALLOCATABLE :: dl_value
-      REAL(dp), DIMENSION(:)      , ALLOCATABLE :: dl_lone
-      REAL(dp), DIMENSION(:)      , ALLOCATABLE :: dl_lonw
-
-      REAL(dp)    :: dl_delta
-      REAL(dp)    :: dl_lonmax
-      REAL(dp)    :: dl_lonmin
-
-      INTEGER(i4) :: il_east
-      INTEGER(i4) :: il_west
-      INTEGER(i4) :: il_jmin
-      INTEGER(i4) :: il_jmax
-
-      INTEGER(i4), PARAMETER :: ip_max_overlap = 5
-
-      ! loop indices
-      INTEGER(i4) :: ji
-      !----------------------------------------------------------------
-      ! init 
-      dom_get_ew_overlap=-1
-
-      il_west=1
-      il_east=td_lon%t_dim(1)%i_len
-
-      ALLOCATE( dl_value(td_lon%t_dim(1)%i_len, &
-      &                  td_lon%t_dim(2)%i_len, &
-      &                  td_lon%t_dim(3)%i_len, &
-      &                  td_lon%t_dim(4)%i_len) )
-
-      dl_value(:,:,:,:)=td_lon%d_value(:,:,:,:)
-      WHERE( dl_value(:,:,:,:) > 180._dp .AND. &
-      &      dl_value(:,:,:,:) /= td_lon%d_fill ) 
-         dl_value(:,:,:,:)=360.-dl_value(:,:,:,:)
-      END WHERE
-
-      ! we do not use jmax as dimension length due to north fold boundary
-      il_jmin=1+ig_ghost
-      il_jmax=(td_lon%t_dim(2)%i_len-ig_ghost)/2
-
-      ALLOCATE( dl_lone(il_jmax-il_jmin+1) )
-      ALLOCATE( dl_lonw(il_jmax-il_jmin+1) )
-
-      dl_lone(:)=dl_value(il_east,il_jmin:il_jmax,1,1)
-      dl_lonw(:)=dl_value(il_west,il_jmin:il_jmax,1,1)
-
-      IF( .NOT.(  ALL(dl_lone(:)==td_lon%d_fill) .AND. &
-      &           ALL(dl_lonw(:)==td_lon%d_fill) ) )THEN
-
-         dl_lonmax=MAXVAL(dl_value(:,il_jmin:il_jmax,:,:))
-         dl_lonmin=MINVAL(dl_value(:,il_jmin:il_jmax,:,:))
-
-         dl_delta=(dl_lonmax-dl_lonmin)/td_lon%t_dim(1)%i_len
-
-         IF( ALL(ABS(dl_lone(:)) - ABS(dl_lonw(:)) == dl_delta) )THEN
-
-            dom_get_ew_overlap=0
-
-         ELSE IF( ALL( ABS(dl_lone(:)) - ABS(dl_lonw(:)) < &
-         &             ip_max_overlap*dl_delta             ) )THEN
-            DO ji=0,ip_max_overlap
-
-               IF( il_east-ji == il_west )THEN
-                  ! case of small domain
-                  EXIT
-               ELSE
-                  dl_lone(:)=dl_value(il_east-ji,il_jmin:il_jmax,1,1)
-                  
-                  IF( ALL( dl_lonw(:) == dl_lone(:) ) )THEN
-                     dom_get_ew_overlap=ji+1
-                     EXIT
-                  ENDIF
-               ENDIF
-
-            ENDDO
-         ENDIF
-
-      ENDIF
-
-      DEALLOCATE( dl_value )
-
-   END FUNCTION dom_get_ew_overlap
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief 
-   !>  This subroutine add extra point to domain
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_dom : domain strcuture
-   !> @param [in] id_iext : i-direction size of extra bands (default=im_minext)
-   !> @param [in] id_jext : j-direction size of extra bands (default=im_minext)
-   !-------------------------------------------------------------------
-   !> @code
+   !>  - domain periodicity is take into account.<br/>
+   !>  - domain indices are changed, and size of extra bands are saved.<br/>
+   !>  - optionaly, i- and j- direction size of extra bands could be specify 
+   !> (default=im_minext)
+   !>
+   !> @author J.Paul
+   !> @date November, 2013
+   !> @date September, 2014
+   !> - take into account number of ghost cell
+   !
+   !> @param[inout] td_dom domain strcuture
+   !> @param [in] id_iext  i-direction size of extra bands (default=im_minext)
+   !> @param [in] id_jext  j-direction size of extra bands (default=im_minext)
+   !-------------------------------------------------------------------
    SUBROUTINE dom_add_extra( td_dom, id_iext, id_jext )
       IMPLICIT NONE
@@ -1288,5 +1314,4 @@
       !----------------------------------------------------------------
       ! init
-      !WARNING: two extrabands are required for cubic interpolation
       il_iext=im_minext
       IF( PRESENT(id_iext) ) il_iext=id_iext
@@ -1305,4 +1330,5 @@
          ! nothing to be done
       ELSE
+
          IF( td_dom%i_imin == 1                       .AND. &
          &   td_dom%i_imax == td_dom%t_dim0(1)%i_len )THEN
@@ -1310,71 +1336,105 @@
             ! nothing to be done
          ELSE
-            IF( td_dom%i_imin /= 1 )THEN
-               td_dom%i_iextra(1)=il_iext
-
-            ELSE
-               IF( td_dom%i_ew0 > 0 )THEN
-                  td_dom%i_iextra(1)=il_iext
-
+            IF( td_dom%i_ew0 < 0 )THEN
+               ! EW not cyclic
+               IF( td_dom%i_imin - il_iext > td_dom%i_ghost0(jp_I,1)*ip_ghost )THEN
+                  td_dom%i_iextra(1) = il_iext
+                  td_dom%i_imin      = td_dom%i_imin - td_dom%i_iextra(1)
+               ELSE ! td_dom%i_imin - il_iext <= td_dom%i_ghost0(jp_I,1)*ip_ghost
+                  td_dom%i_iextra(1) = MIN(0, &
+                  &                         td_dom%i_imin - &
+                  &                         td_dom%i_ghost0(jp_I,1)*ip_ghost -1)
+                  td_dom%i_imin      = td_dom%i_imin - td_dom%i_iextra(1)
                ENDIF
+
+               IF( td_dom%i_imax + il_iext < &
+               &   td_dom%t_dim0(1)%i_len - td_dom%i_ghost0(jp_I,2)*ip_ghost )THEN
+                  td_dom%i_iextra(2) = il_iext
+                  td_dom%i_imax      = td_dom%i_imax + td_dom%i_iextra(2)
+               ELSE ! td_dom%i_imax + il_iext >= &
+                    !  td_dom%t_dim0(1)%i_len - td_dom%i_ghost0(jp_I,2)*ip_ghost
+                  td_dom%i_iextra(2) = MIN(0, &
+                  &                         td_dom%t_dim0(1)%i_len - &
+                  &                         td_dom%i_ghost0(jp_I,2)*ip_ghost - &
+                  &                         td_dom%i_imax )
+                  td_dom%i_imax      = td_dom%i_imax + td_dom%i_iextra(2)
+               ENDIF
+
+            ELSE ! td_dom%i_ew0 >= 0
+               ! EW cyclic
+               IF( td_dom%i_imin - il_iext > 0 )THEN
+                  td_dom%i_iextra(1) = il_iext
+                  td_dom%i_imin      = td_dom%i_imin - td_dom%i_iextra(1)
+               ELSE ! td_dom%i_imin - il_iext <= 0
+                  td_dom%i_iextra(1) = il_iext
+                  td_dom%i_imin      = td_dom%t_dim0(1)%i_len + &
+                  &                     td_dom%i_imin - td_dom%i_iextra(1) -&
+                  &                     td_dom%i_ew0
+               ENDIF
+
+               IF( td_dom%i_imax + il_iext <= td_dom%t_dim0(1)%i_len )THEN
+                  td_dom%i_iextra(2) = il_iext
+                  td_dom%i_imax      = td_dom%i_imax + td_dom%i_iextra(2)
+               ELSE ! td_dom%i_imax + il_iext > td_dom%t_dim0(1)%i_len
+                  td_dom%i_iextra(2) = il_iext
+                  td_dom%i_imax      = td_dom%i_imax + td_dom%i_iextra(2) - &
+                  &                     (td_dom%t_dim0(1)%i_len-td_dom%i_ew0) 
+               ENDIF               
             ENDIF
 
-            IF( td_dom%i_imax /= td_dom%t_dim(1)%i_len )THEN
-               td_dom%i_iextra(2)=1
-
-            ELSE
-               IF( td_dom%i_ew0 > 0 )THEN
-                  td_dom%i_iextra(2)=il_jext
-
-               ENDIF
+         ENDIF
+
+         IF( td_dom%i_jmin == 1                       .AND. &
+         &   td_dom%i_jmax == td_dom%t_dim0(2)%i_len )THEN
+            ! nothing to be done
+         ELSE
+            IF( td_dom%i_jmin - il_jext > td_dom%i_ghost0(jp_J,1)*ip_ghost )THEN
+               td_dom%i_jextra(1) = il_jext
+               td_dom%i_jmin      = td_dom%i_jmin - td_dom%i_jextra(1)
+            ELSE ! td_dom%i_jmin - il_jext <= td_dom%i_ghost0(jp_J,1)*ip_ghost
+               td_dom%i_jextra(1) = MIN(0, &
+               &                         td_dom%i_jmin - &
+               &                         td_dom%i_ghost0(jp_J,1)*ip_ghost - 1)
+               td_dom%i_jmin      = td_dom%i_jmin - td_dom%i_jextra(1)
             ENDIF
 
-         ENDIF
-
-         IF( td_dom%i_jmin == td_dom%i_jmax )THEN
-            td_dom%i_jextra(1)=il_iext
-            td_dom%i_jextra(2)=il_jext
-
-         ELSE
-            IF( td_dom%i_jmin /= 1)THEN
-               td_dom%i_jextra(1)=il_iext
-
+            IF( td_dom%i_jmax + il_jext < &
+            &   td_dom%t_dim0(2)%i_len - td_dom%i_ghost0(jp_J,2)*ip_ghost )THEN
+               td_dom%i_jextra(2) = il_jext
+               td_dom%i_jmax      = td_dom%i_jmax + td_dom%i_jextra(2)
+            ELSE ! td_dom%i_jmax + il_jext >= &
+                 !  td_dom%t_dim0(2)%i_len - td_dom%i_ghost0(jp_J,2)*ip_ghost
+               td_dom%i_jextra(2) = MIN(0, &
+               &                         td_dom%t_dim0(2)%i_len - &
+               &                         td_dom%i_ghost0(jp_J,2)*ip_ghost - &
+               &                         td_dom%i_jmax )
+               td_dom%i_jmax      = td_dom%i_jmax + td_dom%i_jextra(2)
             ENDIF
-            IF( td_dom%i_jmax /= td_dom%t_dim(2)%i_len )THEN
-               td_dom%i_jextra(2)=il_jext
-
-            ENDIF
-
-         ENDIF
-
-      ENDIF
-
-      ! change domain
-      td_dom%i_imin         = td_dom%i_imin - td_dom%i_iextra(1)
-      td_dom%i_jmin         = td_dom%i_jmin - td_dom%i_jextra(1)
-
-      td_dom%i_imax         = td_dom%i_imax + td_dom%i_iextra(2)
-      td_dom%i_jmax         = td_dom%i_jmax + td_dom%i_jextra(2)
-
-      td_dom%t_dim(1)%i_len = td_dom%t_dim(1)%i_len + &
-      &                          td_dom%i_iextra(1) + &
-      &                          td_dom%i_iextra(2)
-      td_dom%t_dim(2)%i_len = td_dom%t_dim(2)%i_len + &
-      &                          td_dom%i_jextra(1) + &
-      &                          td_dom%i_jextra(2)
+         ENDIF         
+
+      ENDIF
+
+      IF( td_dom%i_imin <= td_dom%i_imax )THEN
+         td_dom%t_dim(1)%i_len = td_dom%i_imax - td_dom%i_imin +1 
+      ELSE ! td_dom%i_imin > td_dom%i_imax
+         td_dom%t_dim(1)%i_len = td_dom%i_imax + &
+         &                       td_dom%t_dim0(1)%i_len - td_dom%i_imin + 1 - &
+         &                       td_dom%i_ew0 ! remove overlap
+      ENDIF
+
+      td_dom%t_dim(2)%i_len = td_dom%i_jmax-td_dom%i_jmin+1
 
 
    END SUBROUTINE dom_add_extra
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief 
-   !>  This subroutine clean domain structure. it remove extra point added. 
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_dom : domain strcuture
-   !-------------------------------------------------------------------
-   !> @code
+   !>  This subroutine clean coarse grid domain structure. 
+   !> it remove extra point added. 
+   !
+   !> @author J.Paul
+   !> @date November, 2013
+   !
+   !> @param[inout] td_dom domain strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE dom_clean_extra( td_dom )
       IMPLICIT NONE
@@ -1404,24 +1464,34 @@
 
    END SUBROUTINE dom_clean_extra
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief 
-   !>  This subroutine 
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_var : variable strcuture
-   !> @param[inout] td_dom : domain strcuture
-   !> @param[inout] id_rhoi : i-direction refinement factor
-   !> @param[inout] id_rhoj : j-direction refinement factor
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE dom_del_extra( td_var, td_dom, id_rho )
-      IMPLICIT NONE
-      ! Argument
-      TYPE(TVAR) , INTENT(INOUT) :: td_var
-      TYPE(TDOM) , INTENT(IN   ) :: td_dom
-      INTEGER(i4), DIMENSION(:), INTENT(IN   ) :: id_rho
+   !>  This subroutine delete extra band, from fine grid variable value, 
+   !> and dimension, taking into account refinement factor.
+   !>
+   !> @details
+   !> @note This subroutine should be used before clean domain structure.
+   !>
+   !> @warning if work on coordinates grid, do not remove all extra point.
+   !> save value on ghost cell. 
+   !> 
+   !> @author J.Paul
+   !> @date November, 2013
+   !> @date September, 2014
+   !> - take into account boundary for one point size domain
+   !> @date December, 2014
+   !> - add special case for coordinates file.
+   !
+   !> @param[inout] td_var variable strcuture
+   !> @param[in] td_dom    domain strcuture
+   !> @param[in] id_rho    array of refinement factor
+   !> @param[in] ld_coord  work on coordinates file or not
+   !-------------------------------------------------------------------
+   SUBROUTINE dom_del_extra( td_var, td_dom, id_rho, ld_coord )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TVAR)               , INTENT(INOUT) :: td_var
+      TYPE(TDOM)               , INTENT(IN   ) :: td_dom
+      INTEGER(i4), DIMENSION(:), INTENT(IN   ), OPTIONAL :: id_rho
+      LOGICAL                  , INTENT(IN   ), OPTIONAL :: ld_coord
 
       ! local variable
@@ -1434,8 +1504,23 @@
       INTEGER(i4) :: il_jmax
       
-      REAL(dp), DIMENSION(:,:,:,:), ALLOCATABLE :: dl_value
-
+      INTEGER(i4), DIMENSION(2)   :: il_rho
+      INTEGER(i4), DIMENSION(2,2) :: il_ghost
+
+      REAL(dp)   , DIMENSION(:,:,:,:), ALLOCATABLE :: dl_value
+
+      LOGICAL     :: ll_coord
       ! loop indices
       !----------------------------------------------------------------
+
+      IF( PRESENT(id_rho) )THEN
+         ! work on coarse grid
+         il_rho(:)=id_rho(jp_I:jp_J)
+      ELSE
+         ! work on fine grid
+         il_rho(:)=1
+      ENDIF
+
+      ll_coord=.false.
+      IF( PRESENT(ld_coord) ) ll_coord=ld_coord
 
       IF( .NOT. ASSOCIATED(td_var%d_value) )THEN
@@ -1443,8 +1528,6 @@
          &     "variable "//TRIM(td_var%c_name) )
       ELSE
-         ! get vairbale right domain
+         ! get variable right domain
          IF( ALL(td_var%t_dim(1:2)%l_use) )THEN
-            il_iextra=SUM(td_dom%i_iextra(:))*id_rho(jp_I)
-            il_jextra=SUM(td_dom%i_jextra(:))*id_rho(jp_J)
 
             ALLOCATE(dl_value(td_var%t_dim(1)%i_len, &
@@ -1454,12 +1537,161 @@
             dl_value(:,:,:,:)=td_var%d_value(:,:,:,:)
 
-            il_imin=1                     + td_dom%i_iextra(1)*id_rho(jp_I)
-            il_imax=td_var%t_dim(1)%i_len - td_dom%i_iextra(2)*id_rho(jp_I)
-
-            il_jmin=1                     + td_dom%i_jextra(1)*id_rho(jp_J)
-            il_jmax=td_var%t_dim(2)%i_len - td_dom%i_jextra(2)*id_rho(jp_J)
-
-            td_var%t_dim(1)%i_len=td_var%t_dim(1)%i_len-il_iextra
-            td_var%t_dim(2)%i_len=td_var%t_dim(2)%i_len-il_jextra
+            il_iextra=SUM(td_dom%i_iextra(:))*il_rho(jp_I)
+            il_jextra=SUM(td_dom%i_jextra(:))*il_rho(jp_J)
+
+            il_ghost(:,:)=0
+            IF( ll_coord )THEN
+               il_ghost(:,:)=td_dom%i_ghost(:,:)
+            ENDIF
+
+            IF( il_iextra >= td_var%t_dim(1)%i_len )THEN
+               ! case one point size dimension
+               SELECT CASE(td_dom%i_bdy) 
+
+                  CASE(jp_north,jp_east)
+
+                     CALL logger_info("DOM DEL EXTRA: special case for north"//&
+                     &                " or east boundary.")
+                     IF( td_dom%i_iextra(1) <= 0 )THEN
+                        il_imin= 1
+                        il_ghost(jp_I,1) = 0
+                     ELSE
+                        il_imin= 1 + (td_dom%i_iextra(1)-1)*il_rho(jp_I) + 1 &
+                        &        - il_ghost(jp_I,1)
+                     ENDIF
+                     IF( td_dom%i_iextra(2) <= 0 )THEN;
+                        il_imax= td_var%t_dim(1)%i_len
+                        il_ghost(jp_I,2) = 0
+                     ELSE
+                        il_imax= td_var%t_dim(1)%i_len - &
+                        &          td_dom%i_iextra(2)*il_rho(jp_I) &
+                        &        + il_ghost(jp_I,2)
+                     ENDIF
+
+                  CASE(jp_south,jp_west)
+
+                     CALL logger_info("DOM DEL EXTRA: special case for south"//&
+                     &                " or west boundary.")
+                     IF( td_dom%i_iextra(1) <= 0 )THEN
+                        il_imin= 1
+                        il_ghost(jp_I,1) = 0
+                     ELSE
+                        il_imin= 1 + td_dom%i_iextra(1)*il_rho(jp_I) &
+                        &        - il_ghost(jp_I,1)
+                     ENDIF
+                     IF( td_dom%i_iextra(2) <= 0 )THEN
+                        il_imax= td_var%t_dim(1)%i_len
+                        il_ghost(jp_I,2) = 0
+                     ELSE
+                        il_imax= td_var%t_dim(1)%i_len - &
+                        &          (td_dom%i_iextra(2)-1)*il_rho(jp_I) - 1 &
+                        &        + il_ghost(jp_I,2)
+                     ENDIF
+
+                  CASE DEFAULT
+
+                     IF( MOD(il_iextra-td_var%t_dim(1)%i_len,2)==0 )THEN
+                        ! case one point size dimension with even refinment
+                        CALL logger_fatal("DOM DEL EXTRA: should have been"//&
+                        &                 "an impossible case: domain of "//&
+                        &                 " one point size and even refinment.")
+                     ELSE
+                        il_imin= 1 + &
+                        &        (td_dom%i_iextra(1)-1)*il_rho(jp_I) + &
+                        &        (il_rho(jp_I)-1)/2 + 1                &
+                        &        - il_ghost(jp_I,1)
+                        il_imax= td_var%t_dim(1)%i_len - &
+                        &        (td_dom%i_iextra(2)-1)*il_rho(jp_I) - &
+                        &        (il_rho(jp_I)-1)/2 - 1                &
+                        &        + il_ghost(jp_I,2)
+                     ENDIF
+
+               END SELECT
+
+               td_var%t_dim(1)%i_len = 1 + SUM(il_ghost(jp_I,:))
+
+            ELSE
+               ! general case
+               il_imin=1                     + td_dom%i_iextra(1)*il_rho(jp_I) &
+               &                             - il_ghost(jp_I,1)
+               il_imax=td_var%t_dim(1)%i_len - td_dom%i_iextra(2)*il_rho(jp_I) &
+               &                             + il_ghost(jp_I,2)
+
+               td_var%t_dim(1)%i_len=td_var%t_dim(1)%i_len - il_iextra &
+               &                                         + SUM(il_ghost(jp_I,:))
+            ENDIF
+
+            IF( il_jextra >= td_var%t_dim(2)%i_len )THEN
+               ! case one point size dimension
+               SELECT CASE(td_dom%i_bdy) 
+
+                  CASE(jp_north,jp_east)
+
+                     IF( td_dom%i_jextra(1) <= 0 )THEN
+                        il_jmin= 1
+                        il_ghost(jp_J,1) = 0
+                     ELSE
+                        il_jmin= 1 + (td_dom%i_jextra(1)-1)*il_rho(jp_J) + 1 &
+                        &        - il_ghost(jp_J,1)
+                     ENDIF
+                     IF( td_dom%i_jextra(2) <= 0 )THEN
+                        il_jmax= td_var%t_dim(2)%i_len
+                        il_ghost(jp_J,2) = 0
+                     ELSE
+                        il_jmax= td_var%t_dim(2)%i_len - &
+                        &          td_dom%i_jextra(2)*il_rho(jp_J) &
+                        &        + il_ghost(jp_J,2)
+                     ENDIF
+
+                  CASE(jp_south,jp_west)
+
+                     IF( td_dom%i_iextra(2) <= 0 )THEN
+                        il_jmin= 1
+                        il_ghost(jp_J,1) = 0
+                     ELSE
+                        il_jmin= 1 + td_dom%i_jextra(1)*il_rho(jp_J) &
+                        &        - il_ghost(jp_J,1)
+                     ENDIF
+                     IF( td_dom%i_jextra(2) <= 0 )THEN
+                        il_jmax= td_var%t_dim(2)%i_len
+                        il_ghost(jp_J,2) = 0
+                     ELSE
+                        il_jmax= td_var%t_dim(2)%i_len - &
+                        &          (td_dom%i_jextra(2)-1)*il_rho(jp_J) - 1 &
+                        &        + il_ghost(jp_J,2)
+                     ENDIF
+
+                  CASE DEFAULT
+
+                     IF( MOD(il_jextra-td_var%t_dim(2)%i_len,2)==0 )THEN
+                        ! case one point size dimension with even refinment
+                        CALL logger_fatal("DOM DEL EXTRA: should have been"//&
+                        &                 "an impossible case: domain of "//&
+                        &                 " one point size and even refinment.")
+                     ELSE
+                        il_jmin= 1 + &
+                        &        (td_dom%i_jextra(1)-1)*il_rho(jp_J) + &
+                        &        (il_rho(jp_J)-1)/2 + 1 &
+                        &        - il_ghost(jp_J,1)
+                        il_jmax= td_var%t_dim(2)%i_len - &
+                        &        (td_dom%i_jextra(2)-1)*il_rho(jp_J) - &
+                        &        (il_rho(jp_J)-1)/2 - 1 &
+                        &        + il_ghost(jp_J,2)
+                     ENDIF
+
+               END SELECT
+
+               td_var%t_dim(2)%i_len = 1 + SUM(il_ghost(jp_J,:))
+
+            ELSE
+               ! general case
+               il_jmin=1                     + td_dom%i_jextra(1)*il_rho(jp_J) &
+               &                             - il_ghost(jp_J,1)
+               il_jmax=td_var%t_dim(2)%i_len - td_dom%i_jextra(2)*il_rho(jp_J) &
+               &                             + il_ghost(jp_J,2)
+
+                td_var%t_dim(2)%i_len= td_var%t_dim(2)%i_len - il_jextra &
+                &                                        + SUM(il_ghost(jp_J,:))
+            ENDIF
 
             DEALLOCATE(td_var%d_value)
@@ -1478,15 +1710,13 @@
 
    END SUBROUTINE dom_del_extra
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief 
-   !>  This subroutine clean mpp strcuture.
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_dom : domain strcuture
-   !-------------------------------------------------------------------
-   !> @code
+   !>  This subroutine clean domain structure.
+   !
+   !> @author J.Paul
+   !> @date November, 2013
+   !
+   !> @param[inout] td_dom domain strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE dom_clean( td_dom )
       IMPLICIT NONE
@@ -1495,5 +1725,5 @@
 
       ! local variable
-      TYPE(TDOM) :: tl_dom ! empty file structure
+      TYPE(TDOM) :: tl_dom ! empty dom structure
 
       ! loop indices
@@ -1501,5 +1731,5 @@
       !----------------------------------------------------------------
 
-      CALL logger_info( " CLEAN: reset domain " )
+      CALL logger_info( "DOM CLEAN: reset domain " )
 
       ! del dimension
@@ -1511,4 +1741,4 @@
       td_dom=tl_dom
 
-      END SUBROUTINE dom_clean
+   END SUBROUTINE dom_clean
 END MODULE dom
